#!/bin/bash
OWNER=
OWNERPASS=
RESPONSE=
LOC=
CON=

echo " "
echo "******************************************************************"
echo "*              RPM Testfix TestFix00260565       	               *"
echo "*                                                                *"
echo "* This testfix runs on RPM version 7.0.5.5                       *"
echo "* Please make sure that you have a backup of your database       *"
echo "* before running the testfix.                                    *"
echo "*                                                                *"
echo "******************************************************************"
echo " "




RESPONSE=
while [ "$RESPONSE" != "y" -a  "$RESPONSE" != "Y" -a "$RESPONSE" != "n" -a "$RESPONSE" != "N" ]
do
echo "Do you have a backup of your database?(y/n)"
read RESPONSE
if [ "$RESPONSE" != "y" -a  "$RESPONSE" != "Y" -a "$RESPONSE" != "n" -a "$RESPONSE" != "N" ]; then
	echo "Invalid reply!"
fi
done



if [ "$RESPONSE" != "y" -a "$RESPONSE" != "Y" ]; then
	echo "************************************************************************"
	echo "* Testfix was not applied.                                             *"
	echo "* Reason: no backup.                                                   *"
	echo "* Please try the testfix after getting a backup of your database.      *"
	echo "* Exiting  RPM Testfix TestFix00260565                                 *"
	echo "************************************************************************"
	exit 0
fi



#check oracle_home

if [ "$ORACLE_HOME" != "" ]; then
	echo "**********************************************************************"
	echo " The script has verified that ORACLE_HOME is set to " $ORACLE_HOME
	echo "**********************************************************************"

	RESPONSE=
	while [ "$RESPONSE" != "y" -a  "$RESPONSE" != "Y" -a "$RESPONSE" != "n" -a "$RESPONSE" != "N" ]
	do
		echo "Is this the right value?(y/n)"
		read RESPONSE
		if [ "$RESPONSE" != "y" -a  "$RESPONSE" != "Y" -a "$RESPONSE" != "n" -a "$RESPONSE" != "N" ]; then
			echo "Invalid reply!"
		fi
	done

	if [ "$RESPONSE" != "y" -a "$RESPONSE" != "Y" ]; then
		ORACLE_HOME=
	fi
fi

while [ "$ORACLE_HOME" = "" ]
do
echo "Please enter ORACLE_HOME:"
read ORACLE_HOME
if [ "$ORACLE_HOME" = "" ]; then
	echo "no value for ORACLE_HOME"
fi
done

# check if sqlplus exists
if [ ! -x $ORACLE_HOME/bin/sqlplus ]; then
	echo " "
	echo "*********************************************************************"
	echo "* Testfix was not applied."                                         
	echo "* Reason: sqlplus not found in " $ORACLE_HOME/bin " directory."               
	echo "* Exiting  RPM Testfix TestFix00260565"                            
	echo "*********************************************************************"
	echo " "
	exit 0

fi

# ADD ORACLE_HOME/BIN TO PATH
export PATH=$PATH:$ORACLE_HOME/bin



LOC=
while [ "$LOC" != "y" -a  "$LOC" != "Y" -a "$LOC" != "n" -a "$LOC" != "N" ]
do
        echo "Is your RPM database installed on this machine?(y/n)"
        read LOC
        if [ "$LOC" != "y" -a  "$LOC" != "Y" -a "$LOC" != "n" -a "$LOC" != "N" ]; then
                echo "Invalid reply!"
        fi
done

if [ "$LOC" = "y" -o "$LOC" = "Y" ]; then

	if [ "$ORACLE_SID" != "" ]; then
		echo "**********************************************************************"
		echo " The script has verified that ORACLE_SID is set to " $ORACLE_SID " "
		echo "**********************************************************************"

		RESPONSE=
		while [ "$RESPONSE" != "y" -a  "$RESPONSE" != "Y" -a "$RESPONSE" != "n" -a "$RESPONSE" != "N" ]; do
			echo "Is this the right value"
			read RESPONSE
			if [ "$RESPONSE" != "y" -a  "$RESPONSE" != "Y" -a "$RESPONSE" != "n" -a "$RESPONSE" != "N" ]; then
				echo "Invalid reply!"
			fi
		done

		if [ "$RESPONSE" != "y" -a "$RESPONSE" != "Y" ]; then
			ORACLE_SID=
		fi
	fi

	while [ "$ORACLE_SID" = "" ]
	do
	echo "Please enter ORACLE_SID:"
	read ORACLE_SID
	if [ "$ORACLE_SID" = "" ]; then
		echo "no value for ORACLE_SID"
	fi
	done

else
ORACLE_SID=
	while [ "$ORACLE_SID" = "" ]
	do
	echo "Please enter TNS string:"
	read ORACLE_SID
	if [ "$ORACLE_SID" = "" ]; then
		echo "no value for TNS string"
	fi
	done
fi


export ORACLE_SID


while [ "$OWNER" = "" ]
do
echo "Please enter $ORACLE_SID schema owner:"
read OWNER
if [ "$OWNER" = "" ]; then
	echo "no value for owner"
fi
done

while [ "$OWNERPASS" = "" ]
do
echo "Please enter $ORACLE_SID schema owner password:"
read OWNERPASS
if [ "$OWNERPASS" = "" ]; then
	echo "no value for owner password"
fi
done


if [ "$LOC" = "y" -o  "$LOC" = "Y" ]; then
	CON=$OWNER/$OWNERPASS
elif [ "$LOC" = "n" -o "$LOC" = "N" ]; then
	CON=$OWNER/$OWNERPASS@$ORACLE_SID
fi

sqlplus  /nolog @Database/step0.sql $CON;

if [ "$?" != "0" ]; then
	echo "***********************************************************************"
	echo "* Testfix was not applied.                                            *"
	echo "* Reason: Unable to connect to RPM database.                          *"
	echo "* Exiting RPM Testfix TestFix00260565	                            *"
	echo "***********************************************************************"
	exit 0
fi



echo "***********************************************************"
echo "* Testfix script has gathered all the necessary information"
echo "* to apply the testfix on your database. After applying the"
echo "* testfix, you cannot go back to the old version unless you"
echo "* use your database backup."
echo "***********************************************************"
RESPONSE=
while [ "$RESPONSE" != "y" -a  "$RESPONSE" != "Y" -a "$RESPONSE" != "n" -a "$RESPONSE" != "N" ]
do
        echo "Are you sure you want to apply the testfix to your database now?"
        read RESPONSE
        if [ "$RESPONSE" != "y" -a  "$RESPONSE" != "Y" -a "$RESPONSE" != "n" -a "$RESPONSE" != "N" ]; then
                echo "Invalid reply!"
        fi
done

if [ "$RESPONSE" != "y" -a "$RESPONSE" != "Y" ]; then
	echo "**********************************************************************"
	echo "* Testfix was not applied.                                           *"
	echo "* Reason: Operation was cancelled by the user.                       *"
	echo "* Exiting RPM Testfix TestFix00260565	                           *"
	echo "**********************************************************************"
	exit 0
fi






sqlplus  $CON @./Database/step1.sql;
sqlplus $CON @./Database/migration.sql;

echo "**********************************************************************"
echo "* Testfix TestFix00260565 has been successfully deployed"
echo "**********************************************************************"
exit;
